=== modified file '.bzrignore'
--- .bzrignore	2011-07-10 22:53:59 +0000
+++ .bzrignore	2011-03-10 14:22:12 +0000
@@ -8,5 +8,3 @@
 loggerhead-memprofile
 ./docs/_build/
 tags
-.project
-.pydevproject

=== modified file 'NEWS'
--- NEWS	2011-11-08 16:29:37 +0000
+++ NEWS	2011-03-25 11:38:43 +0000
@@ -39,27 +39,12 @@
       Improves performance on projects with long histories like emacs.
       (John Arbash Meinel)
 
+    - Fix escaping of filenames in revision views.
+      (William Grant, #740142)
+
     - Fix support for displaying foreign revision ids.
       (Jelmer Vernooij, #736026)
 
-    - Add hook 'controller' to BranchWSGIApp, allowing other bzr plugins
-      to provide custom branch-specific controllers. (Jelmer Vernooij, #585822)
-
-    - Add privacy notification code to loggerhead, allowing branches to be
-      marked as private and a notification ribbon to be displayed via
-      javascript on the view pages. (JC Sackett, #823471)
-
-
-1.18.1 [24Mar2011]
-------------------
-
-    - Fix escaping of filenames in revision views.
-      (William Grant, #740142)
-
-    - Add missing import to loggerhead.trace, allowing start-loggerhead
-      to run when a log.roll config option is set.
-      (Max Kanat-Alexander, #673999)
-
 
 1.18 [10Nov2010]
 ----------------

=== modified file 'info.py'
--- info.py	2011-11-23 08:33:12 +0000
+++ info.py	2011-03-19 08:35:57 +0000
@@ -3,12 +3,11 @@
 
 bzr_plugin_name = "loggerhead"
 
-bzr_plugin_version = (1, 18, 1)  # Keep in sync with loggerhead/__init__.py
+bzr_plugin_version = (1, 18, 0)
 
 bzr_compatible_versions = [
     (1, 17, 0), (1, 18, 0), (2, 0, 0), (2, 1, 0), (2, 2, 0), (2, 3, 0),
-    (2, 4, 0), (2, 5, 0),
-    ]
+    (2, 4, 0)]
 
 bzr_minimum_version = bzr_compatible_versions[0]
 

=== modified file 'loggerhead/__init__.py'
--- loggerhead/__init__.py	2011-11-23 08:33:12 +0000
+++ loggerhead/__init__.py	2010-11-11 03:30:43 +0000
@@ -22,7 +22,7 @@
 
 import pkg_resources
 
-__version__ = '1.18.1'  # Keep in sync with ../info.py.
+__version__ = '1.18'
 required_bzrlib = (1, 17)
 
 pkg_resources.get_distribution('Paste>=1.6')

=== modified file 'loggerhead/apps/branch.py'
--- loggerhead/apps/branch.py	2011-11-23 08:18:35 +0000
+++ loggerhead/apps/branch.py	2011-03-16 11:40:05 +0000
@@ -13,7 +13,7 @@
 # You should have received a copy of the GNU General Public License
 # along with this program; if not, write to the Free Software
 # Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
-
+#
 """The WSGI application for serving a Bazaar branch."""
 
 import logging
@@ -22,7 +22,6 @@
 
 import bzrlib.branch
 import bzrlib.errors
-from bzrlib.hooks import Hooks
 import bzrlib.lru_cache
 
 from paste import request
@@ -34,7 +33,7 @@
 from loggerhead.controllers.atom_ui import AtomUI
 from loggerhead.controllers.changelog_ui import ChangeLogUI
 from loggerhead.controllers.diff_ui import DiffUI
-from loggerhead.controllers.download_ui import DownloadUI, DownloadTarballUI
+from loggerhead.controllers.download_ui import DownloadUI
 from loggerhead.controllers.filediff_ui import FileDiffUI
 from loggerhead.controllers.inventory_ui import InventoryUI
 from loggerhead.controllers.revision_ui import RevisionUI
@@ -50,13 +49,7 @@
 
     def __init__(self, branch, friendly_name=None, config={},
                  graph_cache=None, branch_link=None, is_root=False,
-                 served_url=_DEFAULT, use_cdn=False, private=False,
-                 export_tarballs=True):
-        """Create branch-publishing WSGI app.
-
-        :param export_tarballs: If true, allow downloading snapshots of revisions
-            as tarballs.
-        """
+                 served_url=_DEFAULT, use_cdn=False):
         self.branch = branch
         self._config = config
         self.friendly_name = friendly_name
@@ -68,30 +61,25 @@
         self.is_root = is_root
         self.served_url = served_url
         self.use_cdn = use_cdn
-        self.private = private
-        self.export_tarballs = export_tarballs
-
-    def public_private_css(self):
-        if self.private:
-            return "private"
-        else:
-            return "public"
 
     def get_history(self):
+        file_cache = None
         revinfo_disk_cache = None
         cache_path = self._config.get('cachepath', None)
         if cache_path is not None:
             # Only import the cache if we're going to use it.
             # This makes sqlite optional
             try:
-                from loggerhead.changecache import RevInfoDiskCache
+                from loggerhead.changecache import (
+                    FileChangeCache, RevInfoDiskCache)
             except ImportError:
                 self.log.debug("Couldn't load python-sqlite,"
                                " continuing without using a cache")
             else:
+                file_cache = FileChangeCache(cache_path)
                 revinfo_disk_cache = RevInfoDiskCache(cache_path)
         return History(
-            self.branch, self.graph_cache,
+            self.branch, self.graph_cache, file_cache=file_cache,
             revinfo_disk_cache=revinfo_disk_cache, cache_key=self.friendly_name)
 
     def url(self, *args, **kw):
@@ -138,7 +126,6 @@
         'revision': RevisionUI,
         'search': SearchUI,
         'view': ViewUI,
-        'tarball': DownloadTarballUI,
         }
 
     def last_updated(self):
@@ -149,7 +136,7 @@
     def public_branch_url(self):
         return self.branch.get_config().get_user_option('public_branch')
 
-    def lookup_app(self, environ):
+    def app(self, environ, start_response):
         # Check again if the branch is blocked from being served, this is
         # mostly for tests. It's already checked in apps/transport.py
         if self.branch.get_config().get_user_option('http_serve') == 'False':
@@ -171,29 +158,19 @@
                     self.served_url = self.url([])
                 except bzrlib.errors.InvalidURL:
                     self.served_url = None
-        for hook in self.hooks['controller']:
-            controller = hook(self, environ)
-            if controller is not None:
-                return controller
         path = request.path_info_pop(environ)
         if not path:
             raise httpexceptions.HTTPMovedPermanently(
                 self.absolute_url('/changes'))
         if path == 'static':
-            return static_app
-        elif path == '+json':
-            environ['loggerhead.as_json'] = True
-            path = request.path_info_pop(environ)
+            return static_app(environ, start_response)
         cls = self.controllers_dict.get(path)
-        if cls is not None:
-            return cls(self, self.get_history)
-        raise httpexceptions.HTTPNotFound()
-
-    def app(self, environ, start_response):
+        if cls is None:
+            raise httpexceptions.HTTPNotFound()
         self.branch.lock_read()
         try:
             try:
-                c = self.lookup_app(environ)
+                c = cls(self, self.get_history)
                 return c(environ, start_response)
             except:
                 environ['exc_info'] = sys.exc_info()
@@ -201,23 +178,3 @@
                 raise
         finally:
             self.branch.unlock()
-
-
-class BranchWSGIAppHooks(Hooks):
-    """A dictionary mapping hook name to a list of callables for WSGI app branch hooks.
-    """
-
-    def __init__(self):
-        """Create the default hooks.
-        """
-        Hooks.__init__(self, "bzrlib.plugins.loggerhead.apps.branch",
-            "BranchWSGIApp.hooks")
-        self.add_hook('controller',
-            "Invoked when looking for the controller to use for a "
-            "branch subpage. The api signature is (branch_app, environ)."
-            "If a hook can provide a controller, it should return one, "
-            "as a standard WSGI app. If it can't provide a controller, "
-            "it should return None", (1, 19))
-
-
-BranchWSGIApp.hooks = BranchWSGIAppHooks()

=== modified file 'loggerhead/changecache.py'
--- loggerhead/changecache.py	2011-08-17 11:04:00 +0000
+++ loggerhead/changecache.py	2009-05-02 14:01:05 +0000
@@ -99,6 +99,24 @@
             pass
 
 
+class FileChangeCache(object):
+
+    def __init__(self, cache_path):
+
+        if not os.path.exists(cache_path):
+            os.mkdir(cache_path)
+
+        self._changes_filename = os.path.join(cache_path, 'filechanges.sql')
+
+    def get_file_changes(self, entry):
+        cache = FakeShelf(self._changes_filename)
+        changes = cache.get(entry.revid)
+        if changes is None:
+            changes = self.history.get_file_changes_uncached(entry)
+            cache.add(entry.revid, changes)
+        return changes
+
+
 class RevInfoDiskCache(object):
     """Like `RevInfoMemoryCache` but backed in a sqlite DB."""
 

=== modified file 'loggerhead/config.py'
--- loggerhead/config.py	2011-07-07 19:09:11 +0000
+++ loggerhead/config.py	2010-05-12 14:38:05 +0000
@@ -36,7 +36,6 @@
         use_cdn=False,
         sql_dir=None,
         allow_writes=False,
-        export_tarballs=True,
         )
     parser.add_option("--user-dirs", action="store_true",
                       help="Serve user directories as ~user.")
@@ -76,8 +75,6 @@
                       help="The directory to place the SQL cache in")
     parser.add_option("--allow-writes", action="store_true",
                       help="Allow writing to the Bazaar server.")
-    parser.add_option("--export-tarballs", action="store_true",
-                      help="Allow exporting revisions to tarballs.")
     return parser
 
 

=== modified file 'loggerhead/controllers/__init__.py'
--- loggerhead/controllers/__init__.py	2011-07-07 19:09:11 +0000
+++ loggerhead/controllers/__init__.py	2011-03-16 11:40:05 +0000
@@ -18,10 +18,9 @@
 # Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 
 import bzrlib.errors
-import simplejson
 import time
 
-from paste.httpexceptions import HTTPNotFound, HTTPSeeOther
+from paste.httpexceptions import HTTPNotFound
 from paste.request import path_info_pop, parse_querystring
 
 from loggerhead import util
@@ -54,7 +53,6 @@
 class TemplatedBranchView(object):
 
     template_path = None
-    supports_json = False
 
     def __init__(self, branch, history_callable):
         self._branch = branch
@@ -69,7 +67,8 @@
         self.__history = self._history_callable()
         return self.__history
 
-    def parse_args(self, environ):
+    def __call__(self, environ, start_response):
+        z = time.time()
         kwargs = dict(parse_querystring(environ))
         util.set_context(kwargs)
         args = []
@@ -83,45 +82,30 @@
         if len(args) > 1:
             path = unicode('/'.join(args[1:]), 'utf-8')
         self.args = args
-        self.kwargs = kwargs
-        return path
 
-    def add_template_values(self, values):
-        values.update({
+        vals = {
             'static_url': self._branch.static_url,
             'branch': self._branch,
             'util': util,
             'url': self._branch.context_url,
-        })
-        values.update(templatefunctions)
-
-    def __call__(self, environ, start_response):
-        z = time.time()
-        if environ.get('loggerhead.as_json') and not self.supports_json:
-            raise HTTPNotFound
-        path = self.parse_args(environ)
+        }
+        vals.update(templatefunctions)
         headers = {}
-        values = self.get_values(path, self.kwargs, headers)
+
+        vals.update(self.get_values(path, kwargs, headers))
 
         self.log.info('Getting information for %s: %.3f secs' % (
             self.__class__.__name__, time.time() - z))
-        if environ.get('loggerhead.as_json'):
-            headers['Content-Type'] = 'application/json'
-        elif 'Content-Type' not in headers:
+        if 'Content-Type' not in headers:
             headers['Content-Type'] = 'text/html'
         writer = start_response("200 OK", headers.items())
         if environ.get('REQUEST_METHOD') == 'HEAD':
             # No content for a HEAD request
             return []
+        template = load_template(self.template_path)
         z = time.time()
         w = BufferingWriter(writer, 8192)
-        if environ.get('loggerhead.as_json'):
-            w.write(simplejson.dumps(values,
-                default=util.convert_to_json_ready))
-        else:
-            self.add_template_values(values)
-            template = load_template(self.template_path)
-            template.expand_into(w, **values)
+        template.expand_into(w, **vals)
         w.flush()
         self.log.info(
             'Rendering %s: %.3f secs, %s bytes' % (

=== modified file 'loggerhead/controllers/annotate_ui.py'
--- loggerhead/controllers/annotate_ui.py	2011-08-09 14:06:49 +0000
+++ loggerhead/controllers/annotate_ui.py	2011-04-22 17:22:26 +0000
@@ -46,11 +46,7 @@
                     change = self._history.get_changes([line_revid])[0]
                     change_cache[line_revid] = change
 
-                try:
-                    message = change.comment.splitlines()[0]
-                except IndexError:
-                    # Comment not present for this revision
-                    message = ""
+                message = change.comment.splitlines()[0]
 
                 if last_lineno:
                     # The revspan is of lines between the last revision and this one.
@@ -62,10 +58,6 @@
                 last_lineno = lineno
                 last_line_revid = line_revid
 
-        # Zero-size file. Return empty revisions.
-        if last_lineno is None:
-            return revisions
-
         # We never set a revspan for the last revision during the loop above, so set it here.
         revisions[last_lineno].revspan = lineno - last_lineno + 1
 

=== modified file 'loggerhead/controllers/diff_ui.py'
--- loggerhead/controllers/diff_ui.py	2011-06-28 16:51:55 +0000
+++ loggerhead/controllers/diff_ui.py	2011-03-18 09:39:01 +0000
@@ -17,12 +17,12 @@
 #
 
 from cStringIO import StringIO
+import logging
 import time
 
 from paste.request import path_info_pop
 
 from bzrlib.diff import show_diff_trees
-from bzrlib.revision import NULL_REVISION
 
 from loggerhead.controllers import TemplatedBranchView
 
@@ -47,10 +47,8 @@
         revid_from = self._history.fix_revid(revid_from)
         change = self._history.get_changes([revid_from])[0]
 
-        if len(args) == 2:
+        if len(args) is 2:
             revid_to = self._history.fix_revid(args[1])
-        elif len(change.parents) == 0:
-            revid_to = NULL_REVISION
         else:
             revid_to = change.parents[0].revid
 

=== modified file 'loggerhead/controllers/download_ui.py'
--- loggerhead/controllers/download_ui.py	2011-11-25 01:41:07 +0000
+++ loggerhead/controllers/download_ui.py	2010-05-05 19:03:40 +0000
@@ -19,51 +19,46 @@
 
 import logging
 import mimetypes
-import os
 import urllib
 
 from paste import httpexceptions
 from paste.request import path_info_pop
 
 from loggerhead.controllers import TemplatedBranchView
-from loggerhead.exporter import export_archive
 
 log = logging.getLogger("loggerhead.controllers")
 
 
 class DownloadUI (TemplatedBranchView):
 
-    def encode_filename(self, filename):
-
-        return urllib.quote(filename.encode('utf-8'))
-
-    def get_args(self, environ):
+    def __call__(self, environ, start_response):
+        # /download/<rev_id>/<file_id>/[filename]
+
+        h = self._history
+
         args = []
         while True:
             arg = path_info_pop(environ)
             if arg is None:
                 break
             args.append(arg)
-        return args
 
-    def __call__(self, environ, start_response):
-        # /download/<rev_id>/<file_id>/[filename]
-        h = self._history
-        args = self.get_args(environ)
         if len(args) < 2:
             raise httpexceptions.HTTPMovedPermanently(
                 self._branch.absolute_url('/changes'))
+
         revid = h.fix_revid(args[0])
         file_id = args[1]
         path, filename, content = h.get_file(file_id, revid)
         mime_type, encoding = mimetypes.guess_type(filename)
         if mime_type is None:
             mime_type = 'application/octet-stream'
+
         self.log.info('/download %s @ %s (%d bytes)',
                       path,
                       h.get_revno(revid),
                       len(content))
-        encoded_filename = self.encode_filename(filename)
+        encoded_filename = urllib.quote(filename.encode('utf-8'))
         headers = [
             ('Content-Type', mime_type),
             ('Content-Length', str(len(content))),
@@ -72,36 +67,3 @@
             ]
         start_response('200 OK', headers)
         return [content]
-
-
-class DownloadTarballUI(DownloadUI):
-
-    def __call__(self, environ, start_response):
-        """Stream a tarball from a bazaar branch."""
-        # Tried to re-use code from downloadui, not very successful
-        if not self._branch.export_tarballs:
-            raise httpexceptions.HTTPForbidden(
-                "Tarball downloads are not allowed")
-        archive_format = "tgz"
-        history = self._history
-        self.args = self.get_args(environ)
-        if len(self.args):
-            revid = history.fix_revid(self.args[0])
-            version_part = '-r' + self.args[0]
-        else:
-            revid = self.get_revid()
-            version_part = ''
-        # XXX: Perhaps some better suggestion based on the URL or path?
-        #
-        # TODO: Perhaps set the tarball suggested mtime to the revision
-        # mtime.
-        root = self._branch.friendly_name or 'branch'
-        encoded_filename = self.encode_filename(
-            root + version_part + '.' + archive_format)
-        headers = [
-            ('Content-Type', 'application/octet-stream'),
-            ('Content-Disposition',
-                "attachment; filename*=utf-8''%s" % (encoded_filename,)),
-            ]
-        start_response('200 OK', headers)
-        return export_archive(history, root, revid, archive_format)

=== modified file 'loggerhead/controllers/filediff_ui.py'
--- loggerhead/controllers/filediff_ui.py	2011-06-27 15:05:06 +0000
+++ loggerhead/controllers/filediff_ui.py	2009-07-07 23:52:24 +0000
@@ -77,7 +77,6 @@
 class FileDiffUI(TemplatedBranchView):
 
     template_path = 'loggerhead.templates.filediff'
-    supports_json = True
 
     def get_values(self, path, kwargs, headers):
         revid = urllib.unquote(self.args[0])
@@ -88,5 +87,6 @@
             self._history._branch.repository, file_id, compare_revid, revid)
 
         return {
+            'util': util,
             'chunks': chunks,
         }

=== modified file 'loggerhead/controllers/inventory_ui.py'
--- loggerhead/controllers/inventory_ui.py	2011-06-27 16:30:57 +0000
+++ loggerhead/controllers/inventory_ui.py	2010-07-12 15:12:04 +0000
@@ -42,7 +42,6 @@
 class InventoryUI(TemplatedBranchView):
 
     template_path = 'loggerhead.templates.inventory'
-    supports_json = True
 
     def get_filelist(self, inv, path, sort_type, revno_url):
         """
@@ -79,11 +78,6 @@
                 absolutepath = path + '/' + pathname
             revid = entry.revision
 
-            # TODO: For the JSON rendering, this inlines the "change" aka
-            # revision information attached to each file. Consider either
-            # pulling this out as a separate changes dict, or possibly just
-            # including the revision id and having a separate request to get
-            # back the revision info.
             file = util.Container(
                 filename=filename, executable=entry.executable,
                 kind=entry.kind, absolutepath=absolutepath,
@@ -116,6 +110,9 @@
         start_revid = kwargs.get('start_revid', None)
         sort_type = kwargs.get('sort', 'filename')
 
+        # no navbar for revisions
+        navigation = util.Container()
+
         if path is not None:
             path = path.rstrip('/')
             file_id = rev_tree.path2id(path)
@@ -136,7 +133,14 @@
         else:
             updir = dirname(path)
 
+        # Directory Breadcrumbs
+        directory_breadcrumbs = util.directory_breadcrumbs(
+                self._branch.friendly_name,
+                self._branch.is_root,
+                'files')
+
         if not is_null_rev(revid):
+
             change = history.get_changes([ revid ])[0]
             # If we're looking at the tip, use head: in the URL instead
             if revid == branch.last_revision():
@@ -144,49 +148,32 @@
             else:
                 revno_url = history.get_revno(revid)
             history.add_branch_nicks(change)
+
+            # Create breadcrumb trail for the path within the branch
+            branch_breadcrumbs = util.branch_breadcrumbs(path, rev_tree, 'files')
             filelist = self.get_filelist(rev_tree.inventory, path, sort_type, revno_url)
-
         else:
             start_revid = None
             change = None
             path = "/"
             updir = None
             revno_url = 'head:'
+            branch_breadcrumbs = []
             filelist = []
 
         return {
+            'branch': self._branch,
+            'util': util,
             'revid': revid,
             'revno_url': revno_url,
             'change': change,
             'path': path,
             'updir': updir,
             'filelist': filelist,
+            'navigation': navigation,
+            'url': self._branch.context_url,
             'start_revid': start_revid,
-        }
-
-    def add_template_values(self, values):
-        super(InventoryUI, self).add_template_values(values)
-        # Directory Breadcrumbs
-        directory_breadcrumbs = util.directory_breadcrumbs(
-                self._branch.friendly_name,
-                self._branch.is_root,
-                'files')
-
-        path = values['path']
-        revid = values['revid']
-        # no navbar for revisions
-        navigation = util.Container()
-
-        if is_null_rev(revid):
-            branch_breadcrumbs = []
-        else:
-            # Create breadcrumb trail for the path within the branch
-            branch = self._history._branch
-            rev_tree = branch.repository.revision_tree(revid)
-            branch_breadcrumbs = util.branch_breadcrumbs(path, rev_tree, 'files')
-        values.update({
             'fileview_active': True,
             'directory_breadcrumbs': directory_breadcrumbs,
             'branch_breadcrumbs': branch_breadcrumbs,
-            'navigation': navigation,
-        })
+        }

=== modified file 'loggerhead/controllers/revision_ui.py'
--- loggerhead/controllers/revision_ui.py	2011-11-23 08:18:35 +0000
+++ loggerhead/controllers/revision_ui.py	2011-03-02 14:07:21 +0000
@@ -36,7 +36,6 @@
 class RevisionUI(TemplatedBranchView):
 
     template_path = 'loggerhead.templates.revision'
-    supports_json = True
 
     def get_values(self, path, kwargs, headers):
         h = self._history
@@ -45,10 +44,9 @@
         filter_file_id = kwargs.get('filter_file_id', None)
         start_revid = h.fix_revid(kwargs.get('start_revid', None))
         query = kwargs.get('q', None)
+        remember = h.fix_revid(kwargs.get('remember', None))
         compare_revid = h.fix_revid(kwargs.get('compare_revid', None))
 
-        # TODO: This try/except looks to date before real exception handling
-        # and should be removed
         try:
             revid, start_revid, revid_list = h.get_view(revid,
                                                         start_revid,
@@ -57,13 +55,14 @@
         except:
             self.log.exception('Exception fetching changes')
             raise HTTPServerError('Could not fetch changes')
-        # XXX: Some concern about namespace collisions. These are only stored
-        # here so they can be expanded into the template later. Should probably
-        # be stored in a specific dict/etc.
-        self.revid_list = revid_list
-        self.compare_revid = compare_revid
-        self.path = path
-        kwargs['start_revid'] = start_revid
+
+        navigation = util.Container(
+            revid_list=revid_list, revid=revid, start_revid=start_revid,
+            filter_file_id=filter_file_id, pagesize=1,
+            scan_url='/revision', branch=self._branch, feed=True, history=h)
+        if query is not None:
+            navigation.query = query
+        util.fill_in_navigation(navigation)
 
         change = h.get_changes([revid])[0]
 
@@ -73,6 +72,24 @@
             file_changes = h.file_changes_for_revision_ids(
                 compare_revid, change.revid)
 
+        if path in ('', '/'):
+            path = None
+
+        link_data = {}
+        path_to_id = {}
+        if path:
+            item = [x for x in file_changes.text_changes if x.filename == path][0]
+            diff_chunks = diff_chunks_for_file(
+                self._history._branch.repository, item.file_id,
+                item.old_revision, item.new_revision)
+        else:
+            diff_chunks = None
+            for i, item in enumerate(file_changes.text_changes):
+                item.index = i
+                link_data['diff-' + str(i)] = '%s/%s/%s' % (
+                    dq(item.new_revision), dq(item.old_revision), dq(item.file_id))
+                path_to_id[item.filename] = 'diff-' + str(i)
+
         h.add_branch_nicks(change)
 
         if '.' in change.revno:
@@ -87,74 +104,32 @@
         else:
             merged_in = None
 
-        return {
-            'revid': revid,
-            'change': change,
-            'file_changes': file_changes,
-            'merged_in': merged_in,
-        }
-
-    def add_template_values(self, values):
-        super(RevisionUI, self).add_template_values(values)
-        remember = self._history.fix_revid(self.kwargs.get('remember', None))
-        query = self.kwargs.get('q', None)
-        filter_file_id = self.kwargs.get('filter_file_id', None)
-        start_revid = self.kwargs['start_revid']
-        navigation = util.Container(
-            revid_list=self.revid_list, revid=values['revid'],
-            start_revid=start_revid,
-            filter_file_id=filter_file_id, pagesize=1,
-            scan_url='/revision', branch=self._branch, feed=True,
-            history=self._history)
-        if query is not None:
-            navigation.query = query
-        util.fill_in_navigation(navigation)
-        path = self.path
-        if path in ('', '/'):
-            path = None
-
-
-        file_changes = values['file_changes']
-        link_data = {}
-        path_to_id = {}
-        if path:
-            items = [x for x in file_changes.text_changes if x.filename == path]
-            if len(items) > 0:
-                item = items[0]
-                diff_chunks = diff_chunks_for_file(
-                    self._history._branch.repository, item.file_id,
-                    item.old_revision, item.new_revision)
-            else:
-                diff_chunks = None
-        else:
-            diff_chunks = None
-            for i, item in enumerate(file_changes.text_changes):
-                item.index = i
-                link_data['diff-' + str(i)] = '%s/%s/%s' % (
-                    dq(item.new_revision), dq(item.old_revision), dq(item.file_id))
-                path_to_id[item.filename] = 'diff-' + str(i)
-
         # Directory Breadcrumbs
         directory_breadcrumbs = (
             util.directory_breadcrumbs(
                 self._branch.friendly_name,
                 self._branch.is_root,
                 'changes'))
-        can_export = self._branch.export_tarballs
 
-        values.update({
-            'history': self._history,
+        return {
+            'branch': self._branch,
+            'revid': revid,
+            'change': change,
+            'file_changes': file_changes,
+            'diff_chunks': diff_chunks,
             'link_data': simplejson.dumps(link_data),
+            'specific_path': path,
             'json_specific_path': simplejson.dumps(path),
             'path_to_id': simplejson.dumps(path_to_id),
-            'directory_breadcrumbs': directory_breadcrumbs,
+            'start_revid': start_revid,
+            'filter_file_id': filter_file_id,
+            'util': util,
+            'history': h,
+            'merged_in': merged_in,
             'navigation': navigation,
+            'query': query,
             'remember': remember,
-            'compare_revid': self.compare_revid,
-            'filter_file_id': filter_file_id,
-            'diff_chunks': diff_chunks,
-            'query': query,
-            'can_export': can_export,
-            'specific_path': path,
-            'start_revid': start_revid,
-        })
+            'compare_revid': compare_revid,
+            'url': self._branch.context_url,
+            'directory_breadcrumbs': directory_breadcrumbs,
+        }

=== modified file 'loggerhead/controllers/revlog_ui.py'
--- loggerhead/controllers/revlog_ui.py	2011-06-27 15:05:06 +0000
+++ loggerhead/controllers/revlog_ui.py	2009-03-19 00:44:05 +0000
@@ -1,12 +1,12 @@
 import urllib
 
+from loggerhead import util
 from loggerhead.controllers import TemplatedBranchView
 
 
 class RevLogUI(TemplatedBranchView):
 
     template_path = 'loggerhead.templates.revlog'
-    supports_json = True
 
     def get_values(self, path, kwargs, headers):
         history = self._history
@@ -18,7 +18,10 @@
         history.add_branch_nicks(change)
 
         return {
+            'branch': self._branch,
             'entry': change,
             'file_changes': file_changes,
+            'util': util,
             'revid': revid,
+            'url': self._branch.context_url,
         }

=== removed file 'loggerhead/exporter.py'
--- loggerhead/exporter.py	2011-11-24 07:46:41 +0000
+++ loggerhead/exporter.py	1970-01-01 00:00:00 +0000
@@ -1,60 +0,0 @@
-# Copyright (C) 2011 Canonical Ltd
-#
-# This program is free software; you can redistribute it and/or modify
-# it under the terms of the GNU General Public License as published by
-# the Free Software Foundation; either version 2 of the License, or
-# (at your option) any later version.
-#
-# This program is distributed in the hope that it will be useful,
-# but WITHOUT ANY WARRANTY; without even the implied warranty of
-# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
-# GNU General Public License for more details.
-#
-"""Exports an archive from a bazaar branch"""
-
-from bzrlib.export import get_export_generator
-
-
-class ExporterFileObject(object):
-    """Shim that accumulates temporarily written out data.
-
-    There are python tarfile classes that want to write to a file like object.
-    We want to stream data.  But wsgi assumes it can pull data from the
-    handler, rather than having bytes pushed.
-
-    So this class holds the data temporarily, until it is pulled.  It 
-    should never buffer everything because as soon as a chunk is produced, 
-    wsgi will be given the chance to take it.
-    """
-
-    def __init__(self):
-        self._buffer = []
-
-    def write(self, s):
-        self._buffer.append(s)
-
-    def get_buffer(self):
-        try:
-            return ''.join(self._buffer)
-        finally:
-            self._buffer = []
-
-    def close(self):
-        pass
-
-
-def export_archive(history, root, revid, archive_format):
-    """Export tree contents to an archive
-
-    :param history: Instance of history to export
-    :param root: Root location inside the archive.
-    :param revid: Revision to export
-    :param archive_format: Format of the archive, eg 'tar.gz'.
-    """
-    fileobj = ExporterFileObject()
-    tree = history._branch.repository.revision_tree(revid)
-    for _ in get_export_generator(tree=tree, root=root, fileobj=fileobj,
-        format=archive_format):
-        yield fileobj.get_buffer()
-    # Might have additonal contents written
-    yield fileobj.get_buffer()

=== modified file 'loggerhead/history.py'
--- loggerhead/history.py	2012-01-08 22:04:51 +0000
+++ loggerhead/history.py	2011-03-25 13:09:10 +0000
@@ -33,7 +33,6 @@
 import re
 import textwrap
 import threading
-import tarfile
 
 from bzrlib import tag
 import bzrlib.branch
@@ -216,6 +215,8 @@
     around it, serve the request, throw the History object away, unlock the
     branch and throw it away.
 
+    :ivar _file_change_cache: An object that caches information about the
+        files that changed between two revisions.
     :ivar _rev_info: A list of information about revisions.  This is by far
         the most cryptic data structure in loggerhead.  At the top level, it
         is a list of 3-tuples [(merge-info, where-merged, parents)].
@@ -283,10 +284,15 @@
                 self._rev_indices[revid] = seq
                 self._revno_revid[revno_str] = revid
 
-    def __init__(self, branch, whole_history_data_cache,
+    def __init__(self, branch, whole_history_data_cache, file_cache=None,
                  revinfo_disk_cache=None, cache_key=None):
         assert branch.is_locked(), (
             "Can only construct a History object with a read-locked branch.")
+        if file_cache is not None:
+            self._file_change_cache = file_cache
+            file_cache.history = self
+        else:
+            self._file_change_cache = None
         self._branch = branch
         self._branch_tags = None
         self._inventory_cache = {}
@@ -753,13 +759,19 @@
             entry["foreign_revid"] = mapping.vcs.show_foreign_revid(foreign_revid)
         return util.Container(entry)
 
-    def get_file_changes(self, entry):
+    def get_file_changes_uncached(self, entry):
         if entry.parents:
             old_revid = entry.parents[0].revid
         else:
             old_revid = bzrlib.revision.NULL_REVISION
         return self.file_changes_for_revision_ids(old_revid, entry.revid)
 
+    def get_file_changes(self, entry):
+        if self._file_change_cache is None:
+            return self.get_file_changes_uncached(entry)
+        else:
+            return self._file_change_cache.get_file_changes(entry)
+
     def add_changes(self, entry):
         changes = self.get_file_changes(entry)
         entry.changes = changes
@@ -789,8 +801,7 @@
         """
         repo = self._branch.repository
         if (bzrlib.revision.is_null(old_revid) or
-            bzrlib.revision.is_null(new_revid) or
-            old_revid == new_revid):
+            bzrlib.revision.is_null(new_revid)):
             old_tree, new_tree = map(
                 repo.revision_tree, [old_revid, new_revid])
         else:
@@ -805,6 +816,4 @@
             renamed=sorted(reporter.renamed, key=lambda x: x.new_filename),
             removed=sorted(reporter.removed, key=lambda x: x.filename),
             modified=sorted(reporter.modified, key=lambda x: x.filename),
-            text_changes=sorted(reporter.text_changes,
-                                key=lambda x: x.filename))
-
+            text_changes=sorted(reporter.text_changes, key=lambda x: x.filename))

=== modified file 'loggerhead/static/css/global.css'
--- loggerhead/static/css/global.css	2011-11-23 17:21:39 +0000
+++ loggerhead/static/css/global.css	2011-04-22 17:22:49 +0000
@@ -343,68 +343,3 @@
 #footer {
     font-size: 77%;
     }
-
-    
-/* ====================
-   Global notifications
-*/
-/* Move the content down so the notification banner doesn't hide any content. */
-body.global-notification-visible {
-    padding-top: 40px;
-    }
-body.global-notification-visible .login-logout {
-    top: 45px;
-    }
-.notification-private {
-    background-image: url(/static/images/notification-private.png); /* sprite-ref: icon-sprites */
-    background-repeat: no-repeat;
-    }
-.global-notification {
-    position: fixed;
-    z-index: 10;
-    top: 0;
-    left: 0;
-    right: 0;
-    padding: 8px 20px;
-    /* Define colour for browsers that don't support transparency */
-    background-color: #8d1f1f;
-    /* Set transparent background for browsers that support it */
-    background-color: rgba(125,0,0,0.9);
-    color: #fff;
-    text-shadow: 0 -1px 0 #631616;
-    font-size: 14px;
-    line-height: 21px;
-    font-weight: bold;
-    -moz-box-shadow: 0 0 5px #333;
-    -webkit-box-shadow: 0 0 5px #333;
-    box-shadow: 0 0 5px #333;
-    }
-.global-notification .sprite.notification-private {
-    float: left;
-    display: inline-block;
-    height: 21px;
-    width: 20px;
-    margin-right: 10px;
-    padding: 0;
-    }
-.global-notification-close, .global-notification-close:active,
-.global-notification-close:visited {
-    color: #e47a7a;
-    }
-.global-notification-close {
-    display: block;
-    position: absolute;
-    top: 11px;
-    right: 20px;
-    font-size: 12px;
-    font-weight: normal;
-    line-height: 14px;
-    }
-.global-notification-close .sprite.notification-close {
-    float: right;
-    display: block;
-    height: 9px;
-    width: 8px;
-    margin: 3px 0 0 7px;
-    padding: 0;
-    }

=== removed directory 'loggerhead/static/downloads'
=== removed file 'loggerhead/static/images/notification-private.png'
Binary files loggerhead/static/images/notification-private.png and loggerhead/static/images/notification-private.png differ
=== modified file 'loggerhead/static/javascript/custom.js'
--- loggerhead/static/javascript/custom.js	2011-10-26 16:06:54 +0000
+++ loggerhead/static/javascript/custom.js	2009-04-01 15:28:21 +0000
@@ -1,4 +1,4 @@
-Y = YUI().use("base", "node", "io-base", "anim");
+Y = YUI().use("node", "io-base", "anim");
 
 var global_timeout_id = null;
 var global_search_request = null;
@@ -280,89 +280,3 @@
   }
 };
 
-var notification_node = null;
-/*
- * Display privacy notifications
- *
- * This should be called after the page has loaded e.g. on 'domready'.
- */
-function setup_privacy_notification(config) {
-    if (notification_node !== null) {
-        return;
-    }
-    var notification_text = 'The information on this page is private';
-    var hidden = true;
-    var target_id = "loggerheadCont";
-    if (config !== undefined) {
-        if (config.notification_text !== undefined) {
-            notification_text = config.notification_text;
-        }
-        if (config.hidden !== undefined) {
-            hidden = config.hidden;
-        }
-        if (config.target_id !== undefined) {
-            target_id = config.target_id;
-        }
-    }
-    var id_selector = "#" + target_id;
-    var main = Y.get(id_selector);
-    notification_node = Y.Node.create('<div></div>')
-        .addClass('global-notification');
-    if (hidden) {
-        notification_node.addClass('hidden');
-    }
-    var notification_span = Y.Node.create('<span></span>')
-        .addClass('sprite')
-        .addClass('notification-private');
-    notification_node.set('innerHTML', notification_text);
-    main.appendChild(notification_node);
-    notification_node.appendChild(notification_span);
-};
-
-function display_privacy_notification() {
-    /* Set a temporary class on the body for the feature flag,
-     this is because we have no way to use feature flags in
-     css directly. This should be removed if the feature
-     is accepted. */
-    var body = Y.get('body');
-    body.addClass('feature-flag-bugs-private-notification-enabled');
-    // Set the visible flag so that the content moves down.
-    body.addClass('global-notification-visible');
-
-    setup_privacy_notification();
-    var global_notification = Y.get('.global-notification');
-    if (global_notification.hasClass('hidden')) {
-        global_notification.addClass('transparent');
-        global_notification.removeClass('hidden');
-
-        var fade_in = new Y.Anim({
-            node: global_notification,
-            to: {opacity: 1},
-            duration: 0.3
-        });
-        var body_space = new Y.Anim({
-            node: 'body',
-            to: {'paddingTop': '40px'},
-            duration: 0.2,
-            easing: Y.Easing.easeOut
-        });
-        var black_link_space = new Y.Anim({
-            node: '.black-link',
-            to: {'top': '45px'},
-            duration: 0.2,
-            easing: Y.Easing.easeOut
-        });
-
-        fade_in.run();
-        body_space.run();
-        black_link_space.run();
-    }
-};
-
-Y.on('domready', function() {
-    var body = Y.get('body');
-    if (body.hasClass('private')) {
-        setup_privacy_notification();
-        display_privacy_notification();
-    }
-});

=== modified file 'loggerhead/templates/branchinfo.pt'
--- loggerhead/templates/branchinfo.pt	2011-11-25 01:23:32 +0000
+++ loggerhead/templates/branchinfo.pt	2009-01-23 20:53:40 +0000
@@ -1,5 +1,4 @@
-<div id="branch-info"
-  tal:condition="python:branch.served_url">
+<div id="branch-info">
   To get this branch, use: <br/>
   <code>bzr branch
   <tal:served-url tal:replace="python:branch.served_url" /></code>

=== modified file 'loggerhead/templates/macros.pt'
--- loggerhead/templates/macros.pt	2011-11-04 18:16:32 +0000
+++ loggerhead/templates/macros.pt	2011-03-03 10:58:57 +0000
@@ -43,7 +43,7 @@
     <metal:block metal:define-slot="header_extras" />
   </head>
 
- <body tal:attributes="class python:branch.public_private_css()">
+<body>
     <!-- Loggerhead Content Area -->
       
       <div metal:define-slot="backlink" />

=== modified file 'loggerhead/templates/revision.pt'
--- loggerhead/templates/revision.pt	2011-11-23 08:33:55 +0000
+++ loggerhead/templates/revision.pt	2011-02-23 03:01:15 +0000
@@ -73,21 +73,18 @@
           <li tal:condition="python:remember != change.revno">
             <a tal:attributes="href python:url(['/revision', change.revno], remember=change.revno, compare_revid=None);
                                title string:compare with another revision"
-               tal:content="string:compare with another revision"></a></li>
+               tal:content="string:Compare with another revision"></a></li>
           <li tal:condition="python:(remember is not None) and (compare_revid is None) and (change.revno != remember)" >
             <a tal:attributes="href python:url(['/revision', change.revno], compare_revid=history.get_revno(remember))">
               compare with revision <tal:b content="python:history.get_revno(remember)" />
             </a>
           </li>
           <li>
-            <a tal:condition="python:compare_revid is None"
+            <a tal:condition="python:len(change.parents) > 0 and compare_revid is None"
                tal:attributes="href python:url(['/diff', change.revno], clear=1)">download diff</a>
             <a tal:condition="python:compare_revid is not None"
                tal:attributes="href python:url(['/diff', change.revno, history.get_revno(compare_revid)], clear=1)">download diff</a>
-           </li>
-           <li tal:condition="python:can_export">
-            <a tal:attributes="href python:url(['/tarball', change.revno])">download tarball</a>
-           </li>
+          </li>
           <li id="last"><a tal:attributes="href python:url(['/changes', change.revno]);
                                            title string:view history from revision ${change/revno}"
                            tal:content="string:view history from revision ${change/revno}"></a></li>

=== removed file 'loggerhead/tests/fixtures.py'
--- loggerhead/tests/fixtures.py	2011-11-25 02:28:56 +0000
+++ loggerhead/tests/fixtures.py	1970-01-01 00:00:00 +0000
@@ -1,43 +0,0 @@
-# Copyright (C) 2007, 2008, 2009, 2011 Canonical Ltd.
-#
-# This program is free software; you can redistribute it and/or modify
-# it under the terms of the GNU General Public License as published by
-# the Free Software Foundation; either version 2 of the License, or
-# (at your option) any later version.
-#
-# This program is distributed in the hope that it will be useful,
-# but WITHOUT ANY WARRANTY; without even the implied warranty of
-# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
-# GNU General Public License for more details.
-#
-# You should have received a copy of the GNU General Public License
-# along with this program; if not, write to the Free Software
-# Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
-
-from __future__ import absolute_import
-
-from fixtures import Fixture
-
-
-class SampleBranch(Fixture):
-
-    def __init__(self, testcase):
-        # Must be a bzr TestCase to hook into branch creation, unfortunately.
-        self.testcase = testcase
-
-    def setUp(self):
-        Fixture.setUp(self)
-
-        self.tree = self.testcase.make_branch_and_tree('.')
-
-        self.filecontents = (
-            'some\nmultiline\ndata\n'
-            'with<htmlspecialchars\n')
-        filenames = ['myfilename', 'anotherfile<']
-        self.testcase.build_tree_contents(
-            (filename, self.filecontents) for filename in filenames)
-        for filename in filenames:
-            self.tree.add(filename, '%s-id' % filename)
-        self.fileid = self.tree.path2id('myfilename')
-        self.msg = 'a very exciting commit message <'
-        self.revid = self.tree.commit(message=self.msg)

=== modified file 'loggerhead/tests/test_controllers.py'
--- loggerhead/tests/test_controllers.py	2011-11-25 01:41:07 +0000
+++ loggerhead/tests/test_controllers.py	2011-06-28 10:58:27 +0000
@@ -1,61 +1,47 @@
-# Copyright (C) 2008-2011 Canonical Ltd.
-#
-# This program is free software; you can redistribute it and/or modify
-# it under the terms of the GNU General Public License as published by
-# the Free Software Foundation; either version 2 of the License, or
-# (at your option) any later version.
-#
-# This program is distributed in the hope that it will be useful,
-# but WITHOUT ANY WARRANTY; without even the implied warranty of
-# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
-# GNU General Public License for more details.
-#
-# You should have received a copy of the GNU General Public License
-# along with this program; if not, write to the Free Software
-# Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
-
 from cStringIO import StringIO
 import logging
-import tarfile
-import tempfile
 
-from paste.fixture import (
-    AppError,
-    )
 from paste.httpexceptions import HTTPServerError
 
-from testtools.matchers import (
-    Matcher,
-    Mismatch,
-    )
-
 from bzrlib import errors
-import simplejson
 
 from loggerhead.apps.branch import BranchWSGIApp
 from loggerhead.controllers.annotate_ui import AnnotateUI
 from loggerhead.controllers.inventory_ui import InventoryUI
-from loggerhead.tests.test_simple import (
-    BasicTests,
-    consume_app,
-    TestWithSimpleTree,
-    )
+from loggerhead.controllers.revision_ui import RevisionUI
+from loggerhead.tests.test_simple import BasicTests
+from loggerhead import util
 
 
 class TestInventoryUI(BasicTests):
 
-    def make_bzrbranch_for_tree_shape(self, shape):
+    def make_bzrbranch_and_inventory_ui_for_tree_shape(self, shape):
         tree = self.make_branch_and_tree('.')
         self.build_tree(shape)
         tree.smart_add([])
         tree.commit('')
-        self.addCleanup(tree.branch.lock_read().unlock)
-        return tree.branch
+        tree.branch.lock_read()
+        self.addCleanup(tree.branch.unlock)
+        branch_app = BranchWSGIApp(tree.branch, '')
+        branch_app.log.setLevel(logging.CRITICAL)
+        # These are usually set in BranchWSGIApp.app(), which is set from env
+        # settings set by BranchesFromTransportRoot, so we fake it.
+        branch_app._static_url_base = '/'
+        branch_app._url_base = '/'
+        return tree.branch, InventoryUI(branch_app, branch_app.get_history)
 
-    def make_bzrbranch_and_inventory_ui_for_tree_shape(self, shape):
-        branch = self.make_bzrbranch_for_tree_shape(shape)
-        branch_app = self.make_branch_app(branch)
-        return branch, InventoryUI(branch_app, branch_app.get_history)
+    def consume_app(self, app, extra_environ=None):
+        env = {'SCRIPT_NAME': '/files', 'PATH_INFO': ''}
+        if extra_environ is not None:
+            env.update(extra_environ)
+        body = StringIO()
+        start = []
+        def start_response(status, headers, exc_info=None):
+            start.append((status, headers, exc_info))
+            return body.write
+        extra_content = list(app(env, start_response))
+        body.writelines(extra_content)
+        return start[0], body.getvalue()
 
     def test_get_filelist(self):
         bzrbranch, inv_ui = self.make_bzrbranch_and_inventory_ui_for_tree_shape(
@@ -66,8 +52,7 @@
     def test_smoke(self):
         bzrbranch, inv_ui = self.make_bzrbranch_and_inventory_ui_for_tree_shape(
             ['filename'])
-        start, content = consume_app(inv_ui,
-            {'SCRIPT_NAME': '/files', 'PATH_INFO': ''})
+        start, content = self.consume_app(inv_ui)
         self.assertEqual(('200 OK', [('Content-Type', 'text/html')], None),
                          start)
         self.assertContainsRe(content, 'filename')
@@ -75,86 +60,43 @@
     def test_no_content_for_HEAD(self):
         bzrbranch, inv_ui = self.make_bzrbranch_and_inventory_ui_for_tree_shape(
             ['filename'])
-        start, content = consume_app(inv_ui,
-            {'SCRIPT_NAME': '/files', 'PATH_INFO': '',
-             'REQUEST_METHOD': 'HEAD'})
+        start, content = self.consume_app(inv_ui,
+                            extra_environ={'REQUEST_METHOD': 'HEAD'})
         self.assertEqual(('200 OK', [('Content-Type', 'text/html')], None),
                          start)
         self.assertEqual('', content)
 
-    def test_get_values_smoke(self):
-        branch = self.make_bzrbranch_for_tree_shape(['a-file'])
-        branch_app = self.make_branch_app(branch)
-        env = {'SCRIPT_NAME': '', 'PATH_INFO': '/files'}
-        inv_ui = branch_app.lookup_app(env)
-        inv_ui.parse_args(env)
-        values = inv_ui.get_values('', {}, {})
-        self.assertEqual('a-file', values['filelist'][0].filename)
-
-    def test_json_render_smoke(self):
-        branch = self.make_bzrbranch_for_tree_shape(['a-file'])
-        branch_app = self.make_branch_app(branch)
-        env = {'SCRIPT_NAME': '', 'PATH_INFO': '/+json/files'}
-        inv_ui = branch_app.lookup_app(env)
-        self.assertOkJsonResponse(inv_ui, env)
-
 
 class TestRevisionUI(BasicTests):
 
-    def make_branch_app_for_revision_ui(self, shape1, shape2):
+    def make_bzrbranch_and_revision_ui_for_tree_shapes(self, shape1, shape2):
         tree = self.make_branch_and_tree('.')
         self.build_tree_contents(shape1)
         tree.smart_add([])
-        tree.commit('msg 1', rev_id='rev-1')
+        tree.commit('')
         self.build_tree_contents(shape2)
         tree.smart_add([])
-        tree.commit('msg 2', rev_id='rev-2')
-        branch = tree.branch
-        self.addCleanup(branch.lock_read().unlock)
-        return self.make_branch_app(branch)
+        tree.commit('')
+        tree.branch.lock_read()
+        self.addCleanup(tree.branch.unlock)
+        branch_app = BranchWSGIApp(tree.branch)
+        branch_app._environ = {
+            'wsgi.url_scheme':'',
+            'SERVER_NAME':'',
+            'SERVER_PORT':'80',
+            }
+        branch_app._url_base = ''
+        branch_app.friendly_name = ''
+        return tree.branch, RevisionUI(branch_app, branch_app.get_history)
 
     def test_get_values(self):
-        branch_app = self.make_branch_app_for_revision_ui([], [])
-        env = {'SCRIPT_NAME': '', 'PATH_INFO': '/revision/2'}
-        rev_ui = branch_app.lookup_app(env)
-        rev_ui.parse_args(env)
-        self.assertIsInstance(rev_ui.get_values('', {}, []), dict)
-
-    def test_add_template_values(self):
-        branch_app = self.make_branch_app_for_revision_ui(
-                [('file', 'content\n')], [('file', 'new content\n')])
-        env = {'SCRIPT_NAME': '/',
-               'PATH_INFO': '/revision/1/non-existent-file',
-               'QUERY_STRING':'start_revid=1' }
-        revision_ui = branch_app.lookup_app(env)
-        path = revision_ui.parse_args(env)
-        values = revision_ui.get_values(path, revision_ui.kwargs, {})
-        revision_ui.add_template_values(values)
-        self.assertIs(values['diff_chunks'], None)
-
-    def test_get_values_smoke(self):
-        branch_app = self.make_branch_app_for_revision_ui(
-                [('file', 'content\n'), ('other-file', 'other\n')],
-                [('file', 'new content\n')])
-        env = {'SCRIPT_NAME': '/',
-               'PATH_INFO': '/revision/head:'}
-        revision_ui = branch_app.lookup_app(env)
-        revision_ui.parse_args(env)
-        values = revision_ui.get_values('', {}, {})
-
-        self.assertEqual(values['revid'], 'rev-2')
-        self.assertEqual(values['change'].comment, 'msg 2')
-        self.assertEqual(values['file_changes'].modified[0].filename, 'file')
-        self.assertEqual(values['merged_in'], None)
-
-    def test_json_render_smoke(self):
-        branch_app = self.make_branch_app_for_revision_ui(
-                [('file', 'content\n'), ('other-file', 'other\n')],
-                [('file', 'new content\n')])
-        env = {'SCRIPT_NAME': '', 'PATH_INFO': '/+json/revision/head:'}
-        revision_ui = branch_app.lookup_app(env)
-        self.assertOkJsonResponse(revision_ui, env)
-
+        branch, rev_ui = self.make_bzrbranch_and_revision_ui_for_tree_shapes(
+            [], [])
+        rev_ui.args = ['2']
+        util.set_context({})
+        self.assertIsInstance(
+            rev_ui.get_values('', {}, []),
+            dict)
 
 
 class TestAnnotateUI(BasicTests):
@@ -163,16 +105,16 @@
         tree = self.make_branch_and_tree('.')
         self.build_tree_contents([('filename', '')])
         tree.add(['filename'], [file_id])
-        for rev_id, text, message in rev_ids_texts:
+        for rev_id, text in rev_ids_texts:
             self.build_tree_contents([('filename', text)])
-            tree.commit(rev_id=rev_id, message=message)
+            tree.commit(rev_id=rev_id, message='.')
         tree.branch.lock_read()
         self.addCleanup(tree.branch.unlock)
         branch_app = BranchWSGIApp(tree.branch, friendly_name='test_name')
         return AnnotateUI(branch_app, branch_app.get_history)
 
     def test_annotate_file(self):
-        history = [('rev1', 'old\nold\n', '.'), ('rev2', 'new\nold\n', '.')]
+        history = [('rev1', 'old\nold\n'), ('rev2', 'new\nold\n')]
         ann_ui = self.make_annotate_ui_for_file_history('file_id', history)
         # A lot of this state is set up by __call__, but we'll do it directly
         # here.
@@ -183,187 +125,3 @@
         self.assertEqual(2, len(annotated))
         self.assertEqual('2', annotated[1].change.revno)
         self.assertEqual('1', annotated[2].change.revno)
-
-    def test_annotate_empty_comment(self):
-        # Testing empty comment handling without breaking
-        history = [('rev1', 'old\nold\n', '.'), ('rev2', 'new\nold\n', '')]
-        ann_ui = self.make_annotate_ui_for_file_history('file_id', history)
-        ann_ui.args = ['rev2']
-        annotate_info = ann_ui.get_values('filename',
-            kwargs={'file_id': 'file_id'}, headers={})
-
-    def test_annotate_file_zero_sized(self):
-        # Test against a zero-sized file without breaking. No annotation must be present.
-        history = [('rev1', '' , '.')]
-        ann_ui = self.make_annotate_ui_for_file_history('file_id', history)
-        ann_ui.args = ['rev1']
-        annotate_info = ann_ui.get_values('filename',
-            kwargs={'file_id': 'file_id'}, headers={})
-        annotated = annotate_info['annotated']
-        self.assertEqual(0, len(annotated))
-
-
-class TestFileDiffUI(BasicTests):
-
-    def make_branch_app_for_filediff_ui(self):
-        builder = self.make_branch_builder('branch')
-        builder.start_series()
-        builder.build_snapshot('rev-1-id', None, [
-            ('add', ('', 'root-id', 'directory', '')),
-            ('add', ('filename', 'f-id', 'file', 'content\n'))],
-            message="First commit.")
-        builder.build_snapshot('rev-2-id', None, [
-            ('modify', ('f-id', 'new content\n'))])
-        builder.finish_series()
-        branch = builder.get_branch()
-        self.addCleanup(branch.lock_read().unlock)
-        return self.make_branch_app(branch)
-
-    def test_get_values_smoke(self):
-        branch_app = self.make_branch_app_for_filediff_ui()
-        env = {'SCRIPT_NAME': '/',
-               'PATH_INFO': '/+filediff/rev-2-id/rev-1-id/f-id'}
-        filediff_ui = branch_app.lookup_app(env)
-        filediff_ui.parse_args(env)
-        values = filediff_ui.get_values('', {}, {})
-        chunks = values['chunks']
-        self.assertEqual('insert', chunks[0].diff[1].type)
-        self.assertEqual('new content', chunks[0].diff[1].line)
-
-    def test_json_render_smoke(self):
-        branch_app = self.make_branch_app_for_filediff_ui()
-        env = {'SCRIPT_NAME': '/',
-               'PATH_INFO': '/+json/+filediff/rev-2-id/rev-1-id/f-id'}
-        filediff_ui = branch_app.lookup_app(env)
-        self.assertOkJsonResponse(filediff_ui, env)
-
-
-class TestRevLogUI(BasicTests):
-
-    def make_branch_app_for_revlog_ui(self):
-        builder = self.make_branch_builder('branch')
-        builder.start_series()
-        builder.build_snapshot('rev-id', None, [
-            ('add', ('', 'root-id', 'directory', '')),
-            ('add', ('filename', 'f-id', 'file', 'content\n'))],
-            message="First commit.")
-        builder.finish_series()
-        branch = builder.get_branch()
-        self.addCleanup(branch.lock_read().unlock)
-        return self.make_branch_app(branch)
-
-    def test_get_values_smoke(self):
-        branch_app = self.make_branch_app_for_revlog_ui()
-        env = {'SCRIPT_NAME': '/',
-               'PATH_INFO': '/+revlog/rev-id'}
-        revlog_ui = branch_app.lookup_app(env)
-        revlog_ui.parse_args(env)
-        values = revlog_ui.get_values('', {}, {})
-        self.assertEqual(values['file_changes'].added[1].filename, 'filename')
-        self.assertEqual(values['entry'].comment, "First commit.")
-
-    def test_json_render_smoke(self):
-        branch_app = self.make_branch_app_for_revlog_ui()
-        env = {'SCRIPT_NAME': '', 'PATH_INFO': '/+json/+revlog/rev-id'}
-        revlog_ui = branch_app.lookup_app(env)
-        self.assertOkJsonResponse(revlog_ui, env)
-
-
-class TestControllerHooks(BasicTests):
-
-    def test_dummy_hook(self):
-        return
-        # A hook that returns None doesn't influence the searching for
-        # a controller.
-        env = {'SCRIPT_NAME': '', 'PATH_INFO': '/custom'}
-        myhook = lambda app, environ: None
-        branch = self.make_branch('.')
-        self.addCleanup(branch.lock_read().unlock)
-        app = self.make_branch_app(branch)
-        self.addCleanup(BranchWSGIApp.hooks.uninstall_named_hook, 'controller',
-            'captain hook')
-        BranchWSGIApp.hooks.install_named_hook('controller', myhook, "captain hook")
-        self.assertRaises(KeyError, app.lookup_app, env)
-
-    def test_working_hook(self):
-        # A hook can provide an app to use for a particular request.
-        env = {'SCRIPT_NAME': '', 'PATH_INFO': '/custom'}
-        myhook = lambda app, environ: "I am hooked"
-        branch = self.make_branch('.')
-        self.addCleanup(branch.lock_read().unlock)
-        app = self.make_branch_app(branch)
-        self.addCleanup(BranchWSGIApp.hooks.uninstall_named_hook, 'controller',
-            'captain hook')
-        BranchWSGIApp.hooks.install_named_hook('controller', myhook, "captain hook")
-        self.assertEquals("I am hooked", app.lookup_app(env))
-
-
-class IsTarfile(Matcher):
-
-    def __init__(self, compression):
-        self.compression = compression
-
-    def match(self, content_bytes):
-        f = tempfile.NamedTemporaryFile()
-        try:
-            f.write(content_bytes)
-            f.flush()
-            tarfile.open(f.name, mode='r|' + self.compression)
-        finally:
-            f.close()
-
-
-class MatchesTarballHeaders(Matcher):
-
-    def __init__(self, expect_filename):
-        self.expect_filename = expect_filename
-
-    def match(self, response):
-        # Maybe the c-t should be more specific, but this is probably good for
-        # making sure it gets saved without the client trying to decompress it
-        # or anything.
-        if (response.header('Content-Type') == 'application/octet-stream'
-            and response.header('Content-Disposition') ==
-            "attachment; filename*=utf-8''" + self.expect_filename):
-            pass
-        else:
-            return Mismatch("wrong response headers: %r"
-                % response.headers)
-
-
-class TestDownloadTarballUI(TestWithSimpleTree):
-
-    def setUp(self):
-        super(TestDownloadTarballUI, self).setUp()
-
-    def test_download_tarball(self):
-        # Tarball downloads are enabled by default.
-        app = self.setUpLoggerhead()
-        response = app.get('/tarball')
-        self.assertThat(
-            response.body,
-            IsTarfile('gz'))
-        self.assertThat(
-            response,
-            MatchesTarballHeaders('branch.tgz'))
-
-    def test_download_tarball_of_version(self):
-        app = self.setUpLoggerhead()
-        response = app.get('/tarball/1')
-        self.assertThat(
-            response.body,
-            IsTarfile('gz'))
-        self.assertThat(
-            response,
-            MatchesTarballHeaders('branch-r1.tgz'))
-
-    def test_download_tarball_forbidden(self):
-        app = self.setUpLoggerhead(export_tarballs=False)
-        e = self.assertRaises(
-            AppError, 
-            app.get,
-            '/tarball')
-        self.assertContainsRe(
-            str(e),
-            '(?s).*403 Forbidden'
-            '.*Tarball downloads are not allowed')

=== modified file 'loggerhead/tests/test_simple.py'
--- loggerhead/tests/test_simple.py	2011-11-25 02:28:56 +0000
+++ loggerhead/tests/test_simple.py	2011-03-23 03:36:23 +0000
@@ -18,8 +18,6 @@
 import cgi
 import logging
 import re
-import simplejson
-from cStringIO import StringIO
 
 from bzrlib.tests import TestCaseWithTransport
 try:
@@ -33,9 +31,6 @@
 from paste.fixture import TestApp
 from paste.httpexceptions import HTTPExceptionHandler, HTTPMovedPermanently
 
-from loggerhead.tests.fixtures import (
-    SampleBranch,
-    )
 
 
 class BasicTests(TestCaseWithTransport):
@@ -52,42 +47,23 @@
         branch_app = BranchWSGIApp(self.tree.branch, '', **kw).app
         return TestApp(HTTPExceptionHandler(branch_app))
 
-    def assertOkJsonResponse(self, app, env):
-        start, content = consume_app(app, env)
-        self.assertEqual('200 OK', start[0])
-        self.assertEqual('application/json', dict(start[1])['Content-Type'])
-        self.assertEqual(None, start[2])
-        simplejson.loads(content)
-
-    def make_branch_app(self, branch, **kw):
-        branch_app = BranchWSGIApp(branch, friendly_name='friendly-name', **kw)
-        branch_app._environ = {
-            'wsgi.url_scheme':'',
-            'SERVER_NAME':'',
-            'SERVER_PORT':'80',
-            }
-        branch_app._url_base = ''
-        return branch_app
-
 
 class TestWithSimpleTree(BasicTests):
 
     def setUp(self):
         BasicTests.setUp(self)
-        self.sample_branch_fixture = SampleBranch(self)
-
-        # XXX: This could be cleaned up more... -- mbp 2011-11-25
-        self.useFixture(self.sample_branch_fixture)
-        self.tree = self.sample_branch_fixture.tree
-        self.fileid = self.sample_branch_fixture.fileid
-        self.filecontents = self.sample_branch_fixture.filecontents
-        self.msg = self.sample_branch_fixture.msg
-
-    def test_public_private(self):
-        app = self.make_branch_app(self.tree.branch, private=True)
-        self.assertEqual(app.public_private_css(), 'private')
-        app = self.make_branch_app(self.tree.branch)
-        self.assertEqual(app.public_private_css(), 'public')
+        self.createBranch()
+
+        self.filecontents = ('some\nmultiline\ndata\n'
+                             'with<htmlspecialchars\n')
+        filenames = ['myfilename', 'anotherfile<']
+        self.build_tree_contents(
+            (filename, self.filecontents) for filename in filenames)
+        for filename in filenames:
+            self.tree.add(filename, '%s-id' % filename)
+        self.fileid = self.tree.path2id('myfilename')
+        self.msg = 'a very exciting commit message <'
+        self.revid = self.tree.commit(message=self.msg)
 
     def test_changes(self):
         app = self.setUpLoggerhead()
@@ -104,10 +80,7 @@
         res = app.get('/changes')
         self.failUnless("To get this branch, use:" in res)
         self.failUnless("lp:loggerhead" in res)
-
-    def test_no_empty_download_location(self):
-        """With no served_url, no instructions how to get it"""
-        app = self.setUpLoggerhead()
+        app = self.setUpLoggerhead(served_url=None)
         res = app.get('/changes')
         self.failIf("To get this branch, use:" in res)
 
@@ -255,18 +228,6 @@
         self.assertEqualDiff('', res.body)
 
 
-def consume_app(app, env):
-    body = StringIO()
-    start = []
-    def start_response(status, headers, exc_info=None):
-        start.append((status, headers, exc_info))
-        return body.write
-    extra_content = list(app(env, start_response))
-    body.writelines(extra_content)
-    return start[0], body.getvalue()
-
-
-
 #class TestGlobalConfig(BasicTests):
 #    """
 #    Test that global config settings are respected

=== modified file 'loggerhead/util.py'
--- loggerhead/util.py	2011-09-08 00:33:28 +0000
+++ loggerhead/util.py	2011-03-23 05:21:34 +0000
@@ -663,13 +663,3 @@
             else:
                 raise
     return new_application
-
-
-def convert_to_json_ready(obj):
-    if isinstance(obj, Container):
-        d = obj.__dict__.copy()
-        del d['_properties']
-        return d
-    elif isinstance(obj, datetime.datetime):
-        return tuple(obj.utctimetuple())
-    raise TypeError(repr(obj) + " is not JSON serializable")

